semigroupoids-5.2: Semigroupoids: Category sans id

Copyright | (C) 2007-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Data.Semigroupoid.Dual

Description

A semigroupoid satisfies all of the requirements to be a Category except for the existence of identity arrows.

# Documentation

newtype Dual k a b #

Constructors

Dual |
Fields getDual :: k b a

Instances

Category k k1 => Category k (Dual k k k1) # |
Methods id :: cat a a # (.) :: cat b c -> cat a b -> cat a c #
Semigroupoid k k1 => Semigroupoid k (Dual k k k1) # |
Methods o :: c j k -> c i j -> c i k #
Groupoid k k1 => Groupoid k (Dual k k k1) # |
Methods inv :: k a b -> k b a #